-- UTILITY FUNCTIONS

function TuckUF:UtilFactionColors(unit)
	local r, g, b = 0,0,0
	local a = 0.5
	if ( UnitPlayerControlled(unit) ) then
		if ( UnitCanAttack(unit, "player") ) then
			if ( not UnitCanAttack("player", unit) ) then
				r = self.ManaColor[0].r
				g = self.ManaColor[0].g
				b = self.ManaColor[0].b
			else
				r = self.ManaColor[1].r
				g = self.ManaColor[1].g
				b = self.ManaColor[1].b
			end
		elseif ( UnitCanAttack("player", unit) ) then
				r = self.ManaColor[3].r
				g = self.ManaColor[3].g
				b = self.ManaColor[3].b
		elseif ( UnitIsPVP(unit) ) then
			r = self.HealthColor.r
			g = self.HealthColor.g
			b = self.HealthColor.b
		else
			r = self.ManaColor[0].r
			g = self.ManaColor[0].g
			b = self.ManaColor[0].b
		end
	elseif ( UnitIsTapped(unit) and not UnitIsTappedByPlayer(unit) ) or UnitIsDead(unit) then
		r = 0.5
		g = 0.5
		b = 0.5
	else
		local reaction = UnitReaction(unit, "player")
		if ( reaction ) then
			if reaction == 5 or reaction == 6 or reaction == 7 then
				r = self.HealthColor.r
				g = self.HealthColor.g
				b = self.HealthColor.b
			elseif reaction == 4 then
				r = self.ManaColor[3].r
				g = self.ManaColor[3].g
				b = self.ManaColor[3].b
			elseif reaction == 1 or reaction == 2 or reaction == 3 then
				r = self.ManaColor[1].r
				g = self.ManaColor[1].g
				b = self.ManaColor[1].b
			else
				r = UnitReactionColor[reaction].r
				g = UnitReactionColor[reaction].g
				b = UnitReactionColor[reaction].b
			end
		end
	end
	return {r = r,g = g,b = b}
end


function TuckUF:HSV2RGB(h,s,v)
	local h1 = mod(floor(h/60),6)
	local f = h/60 - h1
	local p = v*(1-s)
	local q = v*(1-f*s)
	local t = v*(1-(1-f*s))
	
	if h1==0 then return v,t,p
	elseif h1==1 then return q,v,p
	elseif h1==2 then return p,v,t
	elseif h1==3 then return p,q,v
	elseif h1==4 then return t,p,v
	elseif h1==5 then return v,p,q
	else return 0,0,0 end
end

function TuckUF:GetHealthColor(perc)
	if (perc < 30) then perc = 30 end
	if (perc > 100) then perc = 100 end
	local h = (perc-30)/(70)*120
	local v = 1.0 - (perc-30)/70*0.3
	local s = 1.0
	return TuckUF:HSV2RGB(h,s,v)	
end

function TuckUF:tonum(val, base)
	return tonumber((val or 0), base) or 0
end

function TuckUF:round(num)
	return floor(aUF:tonum(num)+.5)
end

function TuckUF:GetClassColor(unit)
	local class = select(2, UnitClass(unit))
	if UnitIsPlayer(unit) then
		if UnitIsFriend(unit,"player") then
			local color = RAID_CLASS_COLORS[class];
			if(color) then
				return color.r, color.g, color.b; -- same faction PC
			else
				return 0.5, 0.5, 0.5 -- error
			end
		else
			return 1, 0, 0 -- other faction PC
		end
	else
		local reaction = UnitReaction(unit, "player")
		if ( reaction ) then
			if reaction < 4 then
				return 1, 0, 0 -- hostile NPC
			elseif reaction == 4 then
				return 0.5, 0.5, 0.5 -- neutral NPC
			elseif reaction > 4 then
				return 0, 1, 0	-- friendly NPC
			end
		end
		return 0.5, 0.5, 0.5 -- unknown reaction NPC
	end
end